/*You can obtain the driver from
 IDE/Tools/Library_Manager/In_Filter_your_search: type: RFID 522

   All the resources for this project: http://randomnerdtutorials.com/
   Modified by Rui Santos
   Created by FILIPEFLOP
https://randomnerdtutorials.com/security-access-using-mfrc522-rfid-reader-with-arduino/
*/
#include <SPI.h>
#include <MFRC522.h>

#define SS_PIN 10
#define RST_PIN 9
MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.

void setup()
{
  Serial.begin(9600);   // Initiate a serial communication
  SPI.begin();      // Initiate  SPI bus
  mfrc522.PCD_Init();   // Initiate MFRC522
  Serial.println("Approximate your card to the reader...");
  Serial.println();

}
void loop()
{
  // Look for new cards
  if ( ! mfrc522.PICC_IsNewCardPresent())
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial())
  {
    return;
  }
  //Show UID on serial monitor
  Serial.print("UID tag :");
  String content = "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++)
  {
    Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
    Serial.print(mfrc522.uid.uidByte[i], HEX);
    content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
    content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  content.toUpperCase();
  // UID tag : 52 FA BF 10 (white card)
  // UID tag : B5 E8 FD C2 (blue ring)

  if (content.substring(1) == "52 FA BF 10") //change here the UID of the card/cards that you want to give access
  {
    Serial.println("Authorized access yes, yes, yes, yes, yes, yes");
    Serial.println();
    delay(3000);
  }

  else   {
    Serial.println(" Access denied, NO");
    delay(3000);
  }
}
