//2019.5.2 by khwong, test5_LCD_DHT.ino
//1.1) If you are using the lcd module 1602, 16x2 and you will receive the error message of no LiquidCrystal_I2C.h not found.
//   FIX: in Arduino IDE/Sketch/Include library/Add Zip file, select the file from 
//  // https://github.com/johnrickman/LiquidCrystal_I2C   //(bug fixed)
//   if you are using the lcd module 1602, 16x2 and no LiquidCrystal_I2C.h found in your system
//1.2) the control code may be 0x3f, or 0x27, try it yourself
//1.3) //Note:  https://www.geeetech.com/Documents/LiquidCrystal_I2Cv1-1.rar has bug don't use it because it can only print one character per line. 
// this zip file // https://github.com/johnrickman/LiquidCrystal_I2C   //(bug fixed), bug fix of cpp
// ardunio-IDE can read this LiquidCrystal_I2C.cpp and function correctly.

//2)see http://www.circuitbasics.com/how-to-set-up-the-dht11-humidity-sensor-on-an-arduino/ 
// download http://www.circuitbasics.com/wp-content/uploads/2015/10/DHTLib.zip  
//in Arduino IDE/Sketch/Include library/Add Zip file, 

#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <dht.h>//tested ok.
dht DHT ;//DHT DHT;
#define DHT11_PIN 4
//LiquidCrystal_I2C lcd(0x27,20,2);  
// set the LCD address to 0x27 for a 16 chars and 2 line display
LiquidCrystal_I2C lcd(0x3F,20,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display
//LiquidCrystal_I2C lcd(0x3F,16,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display
void setup()
{  Serial.begin(9600);
  lcd.init();                      // initialize the lcd
  lcd.backlight();
  lcd.setCursor(3,0); //first row: line 0,cursor index 3. first postion is index 0
  lcd.print("Hello, world!");
  lcd.setCursor(2,1); //second row : line 1, position index 2
  lcd.print("from KH WONG");
  delay(3000);
  lcd.clear ();
}
void loop() {
  //send himidity and tenmeprature to tool: serial monitor  
  int chk = DHT.read11(DHT11_PIN);
  Serial.print("Temperature = ");
  Serial.println(DHT.temperature);
  Serial.print("Humidity = ");
  Serial.println(DHT.humidity);
  delay(2000); //need longer delay otherwise the senor cannot read correctly
  // read humidity
  float h = DHT.humidity;
  //read temperature
  float f = DHT.temperature;
  if (isnan(h) || isnan(f)) {
    lcd.print("ERROR");
    return;
  }
  lcd.setCursor(0, 0);
  lcd.print("Humidity=");
  lcd.setCursor(10, 0); //first row is humidity
  lcd.print(h);
    lcd.setCursor(0, 1);
  lcd.print("Temperat=");
  lcd.setCursor(10, 1); //first row is humidity 
  lcd.print(f);  
}
